<?php
/**
 * MyBBPlus 2.0.5
 * Copyright 2014 MyBBPlus Group, All Rights Reserved
 *
 * Website: http://www.mybbplus.com
 * License: http://www.mybbplus.com/about/license
 *
 */

/**
 * Upgrade Script: 1.8.3
 */

$upgrade_detail = array(
	"revert_all_templates" => 0,
	"revert_all_themes" => 0,
	"revert_all_settings" => 0,
	"requires_deactivated_plugins" => 1
);

@set_time_limit(0);

function upgrade32_dbchanges()
{
	global $cache, $output, $mybb, $db;

	$output->print_header("Updating Database structures for MyBBPlus");

	echo "<p>Performing necessary upgrade queries...</p>";
	flush();

	switch($db->type)
	{
		case "pgsql":
			$db->add_column("forums", "image", "int(4) NOT NULL default '-1' AFTER fid");
			$db->add_column("privatemessages", "parentid", "int(10) NOT NULL default '0' AFTER pmid");
			$db->add_column("users", "onlymythreads", "tinyint(1) NOT NULL default '0' AFTER subscriptionmethod");
			$db->add_column("users", "bgcolor", "varchar(16) NOT NULL default '#c0c0c0' AFTER sourceeditor");
			$db->add_column("attachments", "pmid", "varchar(240) NOT NULL default '' AFTER posthash");
			$db->add_column("usergroups", "canpmattachments", "tinyint(1) NOT NULL default '0' AFTER canpostattachments");
			break;
		case "sqlite":
			$db->add_column("forums", "image", "int(4) NOT NULL default '-1' AFTER fid");
			$db->add_column("privatemessages", "parentid", "int(10) NOT NULL default '0' AFTER pmid");
			$db->add_column("users", "onlymythreads", "tinyint(1) NOT NULL default '0' AFTER subscriptionmethod");
			$db->add_column("users", "bgcolor", "varchar(16) NOT NULL default '#c0c0c0' AFTER sourceeditor");
			$db->add_column("attachments", "pmid", "varchar(240) NOT NULL default '' AFTER posthash");
			$db->add_column("usergroups", "canpmattachments", "tinyint(1) NOT NULL default '0' AFTER canpostattachments");
			break;
		default:
			$db->add_column("forums", "image", "int(4) NOT NULL default '-1' AFTER fid");
			$db->add_column("privatemessages", "parentid", "int(10) NOT NULL default '0' AFTER pmid");
			$db->add_column("users", "onlymythreads", "tinyint(1) NOT NULL default '0' AFTER subscriptionmethod");
			$db->add_column("users", "bgcolor", "varchar(16) NOT NULL default '#c0c0c0' AFTER sourceeditor");
			$db->add_column("attachments", "pmid", "varchar(240) NOT NULL default '' AFTER posthash");
			$db->add_column("usergroups", "canpmattachments", "tinyint(1) NOT NULL default '0' AFTER canpostattachments");
			break;
	}

//	$db->update_query('profilefields', array('viewableby' => '-1', 'editableby' => '-1'));

	global $footer_extra;
	$footer_extra = "<script type=\"text/javascript\">$(document).ready(function() { var button = $('.submit_button'); if(button) { button.val('Automatic redirection...'); button.prop('disabled', true); button.css('color', '#aaa'); button.css('border-color', '#aaa'); document.forms[0].submit(); } });</script>";

	$output->print_contents("<p>Click next to continue with the upgrade process.</p>");
	$output->print_footer("32_dbchanges2");
}

function upgrade32_dbchanges2()
{
	global $cache, $output, $mybb, $db;

	$output->print_header("Updating Database tables content for MyBBPlus");

	echo "<p>Performing necessary upgrade queries...</p>";
	flush();

	// delete forumpermissions belonging to a deleted forum
	$db->delete_query("forumpermissions", "fid NOT IN(SELECT fid FROM {$db->table_prefix}forums)");

	$db->write_query("INSERT INTO ".TABLE_PREFIX."settinggroups (gid, name, title, description, disporder, isdefault) VALUES (NULL, 'mybbplus', 'MyBBPlus', 'MyBBPLus operation settings...', 0, 'no');");
       $gid = $db->insert_id();
	$db->write_query("INSERT INTO ".TABLE_PREFIX."settings (sid, name, title, description, optionscode, value, disporder, gid, isdefault) VALUES (NULL, 'mybbplus_licence', 'MyBBPlus licence', 'Your licence is assigned for your server and domain name, if you change them, you will need to contact <a href="http://MyBBPlus.com/licence">MyBBPlus</a> to get it modified.', 'text', '', 1, $gid,'no');");
	$db->write_query("INSERT INTO ".TABLE_PREFIX."settings (sid, name, title, description, optionscode, value, disporder, gid, isdefault) VALUES (NULL, 'mybbplus_multidomain', 'Multi domains forum', 'Enter a comma delimited list of all other domains parked over the original one. (Enter just de domain name, like domain.tld)', 'text', '', 2, $gid,'no');");
	$db->write_query("INSERT INTO ".TABLE_PREFIX."settings (sid, name, title, description, optionscode, value, disporder, gid, isdefault) VALUES (NULL, 'mybbplus_geoipdatabasepath', 'Geo Location Database Path', 'This is the path were your geoip database is located. You can point to country or city database. Include the complete path with the filename.', 'text', 'inc/GeoLiteCity.dat', 3, $gid,'no');");
	$db->write_query("INSERT INTO ".TABLE_PREFIX."settings (sid, name, title, description, optionscode, value, disporder, gid, isdefault) VALUES (NULL, 'mybbplus_mapenabled', 'Geolocation Map', 'Select if you want to display the Geolocation map.', 'yesno', '1', 4, $gid,'no');");
	$db->write_query("INSERT INTO ".TABLE_PREFIX."settings (sid, name, title, description, optionscode, value, disporder, gid, isdefault) VALUES (NULL, 'mybbplus_mappoints', 'Maximum number of IPs on the Geolocation map', 'Indicate the maximum number of IPs displayed on the Geolocation map. Leave empty, for no limit on members and 1000 visitors.', 'text', '100', 5, $gid,'no');");
	$db->write_query("INSERT INTO ".TABLE_PREFIX."settings (sid, name, title, description, optionscode, value, disporder, gid, isdefault) VALUES (NULL, 'mybbplus_track_users', 'Track users accessing the forum', 'Keep an entry for each access to the forum in a monthly log file. Enter a "prefix", for your files to turn this feature ON, keep it empty to turn it OFF.', 'text', '', 6, $gid,'no');");
	$db->write_query("INSERT INTO ".TABLE_PREFIX."settings (sid, name, title, description, optionscode, value, disporder, gid, isdefault) VALUES (NULL, 'mybbplus_mobile_theme', 'Mobiles assigned Theme', 'Write the TID of the theme that you want assigned to the mobiles connexions, or the default theme will be used.', 'text', '', 7, $gid,'no');");
	$db->write_query("INSERT INTO ".TABLE_PREFIX."settings (sid, name, title, description, optionscode, value, disporder, gid, isdefault) VALUES (NULL, 'mybbplus_banned_countries', 'Banning Countries', 'Use this option to ban any listed countries to access your forum. Enter the two characters country code in lowercase, separated with commas. (Example "cn,in,pk,ru" for China, India, Pakistan and Russia.)', 'text', '', 8, $gid,'no');");

	$db->write_query("INSERT INTO ".TABLE_PREFIX."settinggroups (gid, name, title, description, disporder, isdefault) VALUES (NULL, 'Regentronique_Translator', 'Regentronique Translation settings', 'Regentronique Translation plugin settings', 0, 'no');");
       $gid = $db->insert_id();
	$db->write_query("INSERT INTO ".TABLE_PREFIX."settings (sid, name, title, description, optionscode, value, disporder, gid, isdefault) VALUES (NULL, 'Regentronique_Translator_Prefix', 'Translation Prefix', 'Prefix used to start the translation string.
                           <br />This prefix must be immediately followed by the language name then a space.<br />
                           <br />Example : <br/><b><i>Prefix</i></b>english Hello<b><i>Separator</i></b>french Bonjour<b><i>Separator</i></b>portuguese Bom Dia<b><i>Suffix</i></b>', 'text', '(*[', 1, $gid,'no');");
	$db->write_query("INSERT INTO ".TABLE_PREFIX."settings (sid, name, title, description, optionscode, value, disporder, gid, isdefault) VALUES (NULL, 'Regentronique_Translator_Suffix', 'Translation Suffix', 'Suffix used to end the translation string.', 'text', ']*)', 2, $gid,'no');");
	$db->write_query("INSERT INTO ".TABLE_PREFIX."settings (sid, name, title, description, optionscode, value, disporder, gid, isdefault) VALUES (NULL, 'Regentronique_Translator_Separator ', 'Translation Separator', 'Separator used to separate all portions of the translation string.
                           <br />This separator must be immediately followed by the language name then a space.<br />
                           <br />Example : <br/><b><i>Prefix</i></b>english Hello<b><i>Separator</i></b>french Bonjour<b><i>Separator</i></b>portuguese Bom Dia<b><i>Suffix</i></b>', 'text', '|', 3, $gid,'no');");
	$db->write_query("INSERT INTO ".TABLE_PREFIX."settings (sid, name, title, description, optionscode, value, disporder, gid, isdefault) VALUES (NULL, 'Regentronique_Translator_Unknown', 'Translation Unknown', 'Unknown string used when the language do not exist in translation string. Leave this blank if you want to see the whole string.', 'text', '?????', 4, $gid,'no');");

	global $footer_extra;
	$footer_extra = "<script type=\"text/javascript\">$(document).ready(function() { var button = $('.submit_button'); if(button) { button.val('Redirection automatique...'); button.prop('disabled', true); button.css('color', '#aaa'); button.css('border-color', '#aaa'); document.forms[0].submit(); } });</script>";

	$output->print_contents("<p>Click next to continue with the upgrade process.</p>");
	$output->print_footer("32_phpcompatibility");
}

function upgrade32_phpcompatibility()
{
	global $lang, $output, $mybb, $db;

	$output->print_header("Verification of PHP options for MyBBPlus");

	echo "<p>Verification of 'short_open_tag'...</p>";
	if(ini_get('short_open_tag') == 1){
	  $short_open_tag = $lang->req_step_span_shorttag_pass;
	  $showerror = 0;
	}else{
	  $short_open_tag = $lang->req_step_span_shorttag_fail;
	  $errors[] =  $lang->sprintf($lang->req_step_error_box, $lang->req_step_span_shorttag_fail);
	  $showerror = 1;
	}
	// Output requirements page
	if( $showerror == 0 ){
	  $output->print_contents("<p>Click next to continue with the upgrade process.</p>");
	  $output->print_footer("32_dbchanges_smilies");
	}else{
	  $output->print_contents("<p>{$short_open_tag}</p>");
	  $output->print_footer();
	}
}

function upgrade32_dbchanges_smilies()
{
	global $cache, $output, $db;

	$output->print_header("Updating Database for MyBBPlus new Smilies");

	echo "<p>Performing necessary upgrade queries...</p>";
	flush();

/*
	if($db->type == 'pgsql')
	{
		$db->modify_column("smilies", "find", "text", "set");
	}
	else
	{
		$db->modify_column("smilies", "find", "text NOT NULL");
	}

	$query = $db->simple_select('smilies', 'sid, image, find', '', array('order_by' => 'image, sid'));
	$last_image = null;
	$last_sid = 0;
	$skip = array();
	while($smilie = $db->fetch_array($query))
	{
		if(in_array($smilie['sid'], $skip))
		{
			continue;
		}

		if($smilie['image'] == $last_image && $smilie['image'] != null)
		{
			$dupe_query = $db->simple_select('smilies', 'sid, find', 'image = "'.$db->escape_string($smilie['image']).'"');
			$dupes = '';
			$find = array();
			$skip = array();
			while($dupe = $db->fetch_array($dupe_query))
			{
				if($dupe['sid'] != $last_sid)
				{
					$dupes .= (int)$dupe['sid'].',';
					$find[] = trim($dupe['find']);
					$skip[] = (int)$dupe['sid'];
				}
				else
				{
					$find[] = $dupe['find'];
				}
			}
			$dupes = rtrim($dupes, ',');
			$db->delete_query('smilies', 'sid IN('.$dupes.')');
			$db->update_query('smilies', array('find' => implode("\n", $find)), 'sid = "'.(int)$last_sid.'"');
			$db->free_result($dupe_query);
		}
		else
		{
			$last_sid = $smilie['sid'];
			$last_image = $smilie['image'];
		}
	}

	$cache->update_smilies();
*/

$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-in-love', ':face-in-love:', 'inc/smileys/face-in-love.png', 53, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-crying-3', ':face-crying-3:', 'inc/smileys/face-crying-3.png', 68, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Opinion-no', ':opinion-no:', 'inc/smileys/opinion-no.png', 94, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-laughing', ':face-laughing:', 'inc/smileys/face-laughing.png', 17, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-pirate', ':face-pirate:', 'inc/smileys/face-pirate.png', 74, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-smile-gearhead-male', ':face-smile-gearhead-male:', 'inc/smileys/face-smile-gearhead-male.png', 93, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Gift', ':gift:', 'inc/smileys/gift.png', 104, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-smile-4', ':face-smile-4:', 'inc/smileys/face-smile-4.png', 5, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-hug-right', ':face-hug-right:', 'inc/smileys/face-hug-right.png', 49, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-raspberry-3', ':face-raspberry-3:', 'inc/smileys/face-raspberry-3.png', 22, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-quiet', ':face-quiet:', 'inc/smileys/face-quiet.png', 77, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-uncertain-2', ':face-uncertain-2:', 'inc/smileys/face-uncertain-2.png', 63, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-angry-2', ':face-angry-2:', 'inc/smileys/face-angry-2.png', 38, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-surprise-2', ':face-surprise-2:', 'inc/smileys/face-surprise-2.png', 57, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-laugh', ':face-laugh:', 'inc/smileys/face-laugh.png', 19, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-smirk', ':face-smirk:', 'inc/smileys/face-smirk.png', 46, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Drink-beer', ':drink-beer:', 'inc/smileys/drink-beer.png', 103, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-crying', ':face-crying:', 'inc/smileys/face-crying.png', 66, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-wink-2', ':face-wink-2:', 'inc/smileys/face-wink-2.png', 9, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-angel-2', ':face-angel-2:', 'inc/smileys/face-angel-2.png', 32, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-cool', ':face-cool:', 'inc/smileys/face-cool.png', 10, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-smile-big-2', ':face-smile-big-2:', 'inc/smileys/face-smile-big-2.png', 20, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-clown', ':face-clown:', 'inc/smileys/face-clown.png', 85, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-worried-2', ':face-worried-2:', 'inc/smileys/face-worried-2.png', 76, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Heart', ':heart:', 'inc/smileys/heart.png', 50, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-devilish-2', ':face-devilish-2:', 'inc/smileys/face-devilish-2.png', 35, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-monkey-2', ':face-monkey-2:', 'inc/smileys/face-monkey-2.png', 84, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-grin', ':face-grin:', 'inc/smileys/face-grin.png', 16, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-kiss-2', ':face-kiss-2:', 'inc/smileys/face-kiss-2.png', 52, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-sick-2', ':face-sick-2:', 'inc/smileys/face-sick-2.png', 70, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-tired', ':face-tired:', 'inc/smileys/face-tired.png', 62, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-confused-2', ':face-confused-2:', 'inc/smileys/face-confused-2.png', 87, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Food', ':food:', 'inc/smileys/food.png', 105, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-sick', ':face-sick:', 'inc/smileys/face-sick.png', 69, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-devilish-3', ':face-devilish-3:', 'inc/smileys/face-devilish-3.png', 36, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Food-cake', ':food-cake:', 'inc/smileys/food-cake.png', 106, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-yawn-2', ':face-yawn-2:', 'inc/smileys/face-yawn-2.png', 75, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-foot-in-mouth', ':face-foot-in-mouth:', 'inc/smileys/face-foot-in-mouth.png', 80, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Rose-wilted', ':rose-wilted:', 'inc/smileys/rose-wilted.png', 102, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Opinion-disagree', ':opinion-disagree:', 'inc/smileys/opinion-disagree.png', 97, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-smile-3', ':face-smile-3:', 'inc/smileys/face-smile-3.png', 4, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-embarrassed', ':face-embarrassed:', 'inc/smileys/face-embarrassed.png', 42, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Drink-martini', ':drink-martini:', 'inc/smileys/drink-martini.png', 99, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-smile-big-4', ':face-smile-big-4:', 'inc/smileys/face-smile-big-4.png', 13, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-hug-left', ':face-hug-left:', 'inc/smileys/face-hug-left.png', 48, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-devilish', ':face-devilish:', 'inc/smileys/face-devilish.png', 34, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Opinion-agree', ':opinion-agree:', 'inc/smileys/opinion-agree.png', 98, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-wink-3', ':face-wink-3:', 'inc/smileys/face-wink-3.png', 7, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-glasses', ':face-glasses:', 'inc/smileys/face-glasses.png', 73, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-ninja', ':face-ninja:', 'inc/smileys/face-ninja.png', 82, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Food-pizza', ':food-pizza:', 'inc/smileys/food-pizza.png', 100, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-cool-2', ':face-cool-2:', 'inc/smileys/face-cool-2.png', 11, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-plain-2', ':face-plain-2:', 'inc/smileys/face-plain-2.png', 79, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-smile-2', ':face-smile-2:', 'inc/smileys/face-smile-2.png', 3, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-star', ':face-star:', 'inc/smileys/face-star.png', 81, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-smile-big-3', ':face-smile-big-3:', 'inc/smileys/face-smile-big-3.png', 14, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-smile-gearhead-female', ':face-smile-gearhead-female:', 'inc/smileys/face-smile-gearhead-female.png', 92, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-surprise', ':face-surprise:', 'inc/smileys/face-surprise.png', 58, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-smirk-2', ':face-smirk-2:', 'inc/smileys/face-smirk-2.png', 45, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-glasses-2', ':face-glasses-2:', 'inc/smileys/face-glasses-2.png', 72, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-sad-4', ':face-sad-4:', 'inc/smileys/face-sad-4.png', 29, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-angel-3', ':face-angel-3:', 'inc/smileys/face-angel-3.png', 31, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-sad-3', ':face-sad-3:', 'inc/smileys/face-sad-3.png', 27, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-monkey', ':face-monkey:', 'inc/smileys/face-monkey.png', 83, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-raspberry-2', ':face-raspberry-2:', 'inc/smileys/face-raspberry-2.png', 21, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-sad-2', ':face-sad-2:', 'inc/smileys/face-sad-2.png', 26, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-angel', ':face-angel:', 'inc/smileys/face-angel.png', 30, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-plain-3', ':face-plain-3:', 'inc/smileys/face-plain-3.png', 78, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-laugh-2', ':face-laugh-2:', 'inc/smileys/face-laugh-2.png', 15, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-smile-grin', ':face-smile-grin:', 'inc/smileys/face-smile-grin.png', 1, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-wink-4', ':face-wink-4:', 'inc/smileys/face-wink-4.png', 6, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Rose', ':rose:', 'inc/smileys/rose.png', 101, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Heart-broken', ':heart-broken:', 'inc/smileys/heart-broken.png', 95, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-angry', ':face-angry:', 'inc/smileys/face-angry.png', 37, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-embarrassed-2', ':face-embarrassed-2:', 'inc/smileys/face-embarrassed-2.png', 40, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-sleeping-2', ':face-sleeping-2:', 'inc/smileys/face-sleeping-2.png', 60, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-worried', ':face-worried:', 'inc/smileys/face-worried.png', 43, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-crying-2', ':face-crying-2:', 'inc/smileys/face-crying-2.png', 65, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-sleep', ':face-sleep:', 'inc/smileys/face-sleep.png', 59, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Opinion-okay', ':opinion-okay:', 'inc/smileys/opinion-okay.png', 96, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-surprise-3', ':face-surprise-3:', 'inc/smileys/face-surprise-3.png', 56, 1);";
$inserts[] = "INSERT INTO ".TABLE_PREFIX."smilies (name, find, image, disporder, showclickable) VALUES('Face-kiss-3', ':face-kiss-3:', 'inc/smileys/face-kiss-3.png', 51, 1);";
	foreach($inserts as $insert){
	  $db->write_query($insert);
	}
	$output->print_contents("<p>Click next to continue with the upgrade process.</p>");
	$output->print_footer("32_updatetheme");
}

function upgrade32_updatetheme()
{
	global $db, $mybb, $output, $config;

/*
	if(file_exists(MYBB_ROOT.$mybb->config['admin_dir']."/inc/functions_themes.php"))
	{
		require_once MYBB_ROOT.$mybb->config['admin_dir']."/inc/functions_themes.php";
	}
	else if(file_exists(MYBB_ROOT."admin/inc/functions_themes.php"))
	{
		require_once MYBB_ROOT."admin/inc/functions_themes.php";
	}
	else
	{
		$output->print_error("Be assured that the admin folder have been correctly uploaded.");
	}

	$output->print_header("Updating themes for MyBBPlus");

	// New default user star
	$contents = "<p>Updating default theme... ";
	$db->update_query("usergroups", array('starimage' => 'images/star.png'), "starimage='images/star.gif'");
	$contents .= "done.</p>";

	$contents .= "<p>Adding new stylesheets... ";
	
	$query = $db->simple_select("themes", "*", "tid='1'");

	$theme = $db->fetch_array($query);
	$properties = my_unserialize($theme['properties']);
	$stylesheets = my_unserialize($theme['stylesheets']);

	$old = array("global.css", "usercp.css", "modcp.css", "star_ratings.css");
	require_once MYBB_ROOT."inc/class_xml.php";
	$colors = @file_get_contents(INSTALL_ROOT.'resources/mybb_theme.xml');
	$parser = new XMLParser($colors);
	$tree = $parser->get_tree();

	if(is_array($tree) && is_array($tree['theme']))
	{
		if(is_array($tree['theme']['stylesheets']))
		{
			foreach($tree['theme']['stylesheets']['stylesheet'] as $stylesheet)
			{
				$new_stylesheet = array(
					"name" => $db->escape_string($stylesheet['attributes']['name']),
					"tid" => 1,
					"attachedto" => $db->escape_string($stylesheet['attributes']['attachedto']),
					"stylesheet" => $db->escape_string($stylesheet['value']),
					"lastmodified" => TIME_NOW,
					"cachefile" => $db->escape_string($stylesheet['attributes']['name'])
				);

				if(in_array($new_stylesheet['name'], $old))
				{
					// We can update the disporder here
					$properties['disporder'][$stylesheet['attributes']['name']] = $stylesheet['attributes']['disporder'];
				}
				else
				{
					// Insert new stylesheet
					$sid = $db->insert_query("themestylesheets", $new_stylesheet);
					$css_url = "css.php?stylesheet={$sid}";

					$cached = cache_stylesheet($tid, $stylesheet['attributes']['name'], $stylesheet['value']);

					if($cached)
					{
						$css_url = $cached;
					}

					// Add to display and stylesheet list
					$properties['disporder'][$stylesheet['attributes']['name']] = $stylesheet['attributes']['disporder'];
					$attachedto = $stylesheet['attributes']['attachedto'];
					if(!$attachedto)
					{
						$attachedto = "global";
					}

					// private.php?compose,folders|usercp.php,global|global
					$attachedto = explode("|", $attachedto);
					foreach($attachedto as $attached_file)
					{
						$attached_actions = explode(",", $attached_file);
						$attached_file = array_shift($attached_actions);
						if(count($attached_actions) == 0)
						{
							$attached_actions = array("global");
						}

						foreach($attached_actions as $action)
						{
							$stylesheets[$attached_file][$action][] = $css_url;
						}
					}
				}
			}
		}
	}

	$update_array = array(
		"properties" => $db->escape_string(serialize($properties)),
		"stylesheets" => $db->escape_string(serialize($stylesheets))
	);

	$db->update_query("themes", $update_array, "tid = '1'");

	$contents .= "done.</p>";

	$contents .= "<p>Adding a disporder to all stylesheets... ";

	$query = $db->simple_select("themes", "tid,properties,stylesheets");
	while($theme = $db->fetch_array($query))
	{
		$properties = my_unserialize($theme['properties']);
		$stylesheets = my_unserialize($theme['stylesheets']);

		// Disporder already set?
		if(isset($properties['disporder']) && !empty($properties['disporder']))
		{
			continue;
		}

		$disporder = 1;

		// First go through all own stylesheets
		$query2 = $db->simple_select("themestylesheets", "name", "tid='{$theme['tid']}'");
		while($name = $db->fetch_field($query2, "name"))
		{
			$properties['disporder'][$name] = $disporder;
			$disporder++;
		}

		// Next go through the inherited stylesheets
		if(!empty($stylesheets))
		{
			foreach($stylesheets as $a)
			{
				foreach($a as $file => $stylesheet)
				{
					// Don't ask me... Throws an error otherwise
					if(empty($stylesheet))
					{
						continue;
					}
					foreach($stylesheet as $s)
					{
						$name = pathinfo($s, PATHINFO_BASENAME);
						if(empty($properties['disporder']) || !in_array($name, array_keys($properties['disporder'])))
						{
							$properties['disporder'][$name] = $disporder;
							$disporder++;
						}
					}
				}
			}
		}

		$db->update_query("themes", array("properties" => $db->escape_string(serialize($properties))), "tid='{$theme['tid']}'");
	}

	$contents .= "finished.</p>";

	$contents .= "<p>Adding default colors... ";

	$query = $db->simple_select("themes", "*", "tid = '2'");

	// Someone deleted the default theme... :o
	if($db->num_rows($query) != 0)
	{
		$theme = $db->fetch_array($query);
		$properties = my_unserialize($theme['properties']);
		$stylesheets = my_unserialize($theme['stylesheets']);
		
		$properties['editortheme'] = "mybb.css"; // New editor, so reset the theme for it
		$properties['tablespace'] = 5;
		$properties['borderwidth'] = 0;
		// Reset the logo if it's still the default one
		if($properties['logo'] == "images/logo.gif")
		{
			$properties['logo'] = "images/logo.png";
		}
	
		require_once MYBB_ROOT."inc/class_xml.php";
		$colors = @file_get_contents(INSTALL_ROOT.'resources/mybb_theme_colors.xml');
		$parser = new XMLParser($colors);
		$tree = $parser->get_tree();
	
		if(is_array($tree) && is_array($tree['colors']))
		{
			if(is_array($tree['colors']['scheme']))
			{
				foreach($tree['colors']['scheme'] as $tag => $value)
				{
					$exp = explode("=", $value['value']);
	
					$properties['colors'][$exp[0]] = $exp[1];
				}
			}
	
			if(is_array($tree['colors']['stylesheets']))
			{
				$count = count($properties['disporder']) + 1;
				foreach($tree['colors']['stylesheets']['stylesheet'] as $stylesheet)
				{
					$new_stylesheet = array(
						"name" => $db->escape_string($stylesheet['attributes']['name']),
						"tid" => 2,
						"attachedto" => $db->escape_string($stylesheet['attributes']['attachedto']),
						"stylesheet" => $db->escape_string($stylesheet['value']),
						"lastmodified" => TIME_NOW,
						"cachefile" => $db->escape_string($stylesheet['attributes']['name'])
					);
	
					$sid = $db->insert_query("themestylesheets", $new_stylesheet);
					$css_url = "css.php?stylesheet={$sid}";
	
					$cached = cache_stylesheet($tid, $stylesheet['attributes']['name'], $stylesheet['value']);
	
					if($cached)
					{
						$css_url = $cached;
					}
	
					// Add to display and stylesheet list
					$properties['disporder'][$stylesheet['attributes']['name']] = $count;
					$stylesheets[$stylesheet['attributes']['attachedto']]['global'][] = $css_url;
	
					++$count;
				}
			}
	
			$update_array = array(
				"properties" => $db->escape_string(serialize($properties)),
				"stylesheets" => $db->escape_string(serialize($stylesheets))
			);
	
			$db->update_query("themes", $update_array, "tid = '2'");
		}
	}

	$contents .= "done.</p>";

	$contents .= '<p>Refreshing the cache and minimizing the existing stylesheets...</p>';

	$num_re_cached = recache_existing_styles();

	$contents .= "Finished. {$num_re_cached} stylesheet refreshed.";

	echo $contents;

*/
	$output->print_contents("<p>Click next to continue with the upgrade process.</p>");
	$output->print_footer("32_addplugins");
}

function upgrade32_addplugins()
{
	global $cache, $output, $db, $mybb, $plugins, $lang2;

	$output->print_header("Updating plugins for MyBBPlus");

	echo "<p>Performing necessary upgrade queries...</p>";
	flush();

//exdiogene begin
	if(file_exists(MYBB_ROOT.'inc/class_mybbplus.php')){
	  unlink(MYBB_ROOT.'inc/class_mybbplus.php');
	}
	rename(MYBB_ROOT.'inc/class_mybbplus.bin',MYBB_ROOT.'inc/class_mybbplus.php');

	if(file_exists(MYBB_ROOT.'inc/plugins/Regentronique_Plugins_Manager.php')){
	  unlink(MYBB_ROOT.'inc/plugins/Regentronique_Plugins_Manager.php');
	}
	rename(MYBB_ROOT.'inc/plugins/Regentronique_Plugins_Manager.bin',MYBB_ROOT.'inc/plugins/Regentronique_Plugins_Manager.php');

	if(file_exists(MYBB_ROOT.'inc/plugins/Regentronique_Translator.php')){
	  unlink(MYBB_ROOT.'inc/plugins/Regentronique_Translator.php');
	}
	rename(MYBB_ROOT.'inc/plugins/Regentronique_Translator.bin',MYBB_ROOT.'inc/plugins/Regentronique_Translator.php');
//exdiogene end

	// Load plugin system for verification
//	require_once MYBB_ROOT."inc/class_plugins.php";
//	$pluginsystem = new pluginSystem;
	if($db->table_exists("datacache")){
		$the_plugins = $cache->read('plugins', true);
		$the_plugins['active']['Regentronique_Translator'] = 'Regentronique_Translator';
		$the_plugins['active']['Regentronique_Plugins_Manager'] = 'Regentronique_Plugins_Manager';
		$cache->update('plugins', $the_plugins);
	}

	$output->print_contents("<p>Click next to continue with the upgrade process.</p>");
	$output->print_footer("32_addtask");
}

function upgrade32_addtask()
{
	global $cache, $output, $db, $lang2, $mybb, $plugin;

       include_once MYBB_ROOT."inc/functions_task.php";

	$output->print_header("Updating tasks and downloading Geolocation Database for MyBBPlus");

	echo "<p>Performing necessary upgrade queries...</p>";
			$new_task = array(
				'title' => $db->escape_string('Updating the Geolocation DataBase'),
				'description' => $db->escape_string('Update the Geolocation DataBase.'),
				'file' => $db->escape_string('geotablerefresh'),
				'minute' => $db->escape_string('*'),
				'hour' => $db->escape_string('*'),
				'day' => $db->escape_string('1'),
				'weekday' => $db->escape_string('*'),
				'month' => $db->escape_string('*'),
				'enabled' => $db->escape_string('1'),
				'logging' => $db->escape_string('1')
			);

			$new_task['nextrun'] = fetch_next_run($new_task);

			$My_ID = $db->insert_query("tasks", $new_task);
				$mybb->settings['mybbplus_geoipdatabasepath'] = 'inc/GeoLiteCity.dat';
				echo $lang->geotablerefresh_update;
				run_task($My_ID);
				echo $lang->geotablerefresh_updatedone;
			} 
	$output->print_contents("<p>Click next to continue with the upgrade process.</p>");

	$output->print_footer("32_done");
}

/**
 * Re-cache the existing stylesheets so that they get minified.
 *
 * @return int The number of re-cached stylesheets.
 */
function recache_existing_styles()
{
	global $db;

	$query = $db->simple_select('themestylesheets', '*');

	$num_updated = 0;

	while($stylesheet = $db->fetch_array($query))
	{
		if (cache_stylesheet((int) $stylesheet['tid'], $stylesheet['name'], $stylesheet['stylesheet']))
		{
			++$num_updated;
		}
	}

	return $num_updated;
}