<?php
/*
function LatitudeToYpos($lat,$h){
  return 16 + ((($h /150 ) * 90) * 1.03) - ((($lat * (1 + abs($lat / 100)) ) * ($h / 250))); 
}
function LongitudeToXpos($long,$w){
  return 8 + (($w /360 ) * 166) + ($long * ($w / 360)); 
}
*/
function LatitudeToYpos($lat,$h){
  return 17.25 + (($h /150 ) * 70.5) - ($lat * ($h / 180)); 
}
function LongitudeToXpos($long,$w){
  return 123.5 + (($w /360 ) * 140.5) + ($long * ($w / 363)); 
}

function imagelinethick($image, $x1, $y1, $x2, $y2, $color, $thick = 1) {
    /* de cette manire, ca ne marche bien que pour les lignes orthogonales
    imagesetthickness($image, $thick);
    return imageline($image, $x1, $y1, $x2, $y2, $color);
    */
    if ($thick == 1) {
        return imageline($image, $x1, $y1, $x2, $y2, $color);
    }
    $t = $thick / 2 - 0.5;
    if ($x1 == $x2 || $y1 == $y2) {
        return imagefilledrectangle($image, round(min($x1, $x2) - $t), round(min($y1, $y2) - $t), round(max($x1, $x2) + $t), round(max($y1, $y2) + $t), $color);
    }
    $k = ($y2 - $y1) / ($x2 - $x1); //y = kx + q
    $a = $t / sqrt(1 + pow($k, 2));
    $points = array(
        round($x1 - (1+$k)*$a), round($y1 + (1-$k)*$a),
        round($x1 - (1-$k)*$a), round($y1 - (1+$k)*$a),
        round($x2 + (1+$k)*$a), round($y2 - (1-$k)*$a),
        round($x2 + (1-$k)*$a), round($y2 + (1+$k)*$a),
    );
        imagefilledpolygon($image, $points, 4, $color);
    return imagepolygon($image, $points, 4, $color);
}

$MinimumDistance = 13.5;
$MidLat = 183;
$SpotsArray = Array();

function ChooseMapPosition($lat, $long){
  global $SpotsArray,$MinimumDistance,$MidLat;
  $SpotsArray2 = array_merge($SpotsArray);
  foreach ($SpotsArray as $Spot){
   if ((abs($Spot[0] - $lat) + abs($Spot[1] - $long)) < $MinimumDistance){
//     $test = 0;
     $GotSpot = 0;
     $x = $long;
     if ($lat < $MidLat){
       $y = $MidLat - 137;
     }else{
       $y = $MidLat + 137;
     }
     while ($GotSpot == 0){
       $GotSpot = 1;
//       $test++;
//       reset($SpotsArray2);
       foreach ($SpotsArray2 as $Spot2){
         if (($Spot2[0] == $y) && (abs($Spot2[1] - $x) < 16)){
           $GotSpot = 0;
           if (($Spot2[1] - $x) < 0){
             if ((abs($Spot2[1] - $x) % 16) == 0){
               $x = $x +16;
             }else{  
               $x = $Spot2[1] +16;
             }
           }else{
             if ((abs($Spot2[1] - $x) % 16) == 0){
               $x = $x -16;
             }else{  
               $x = $Spot2[1] -16;
             }
           }
           break;
         }
       }
     }
     $SpotsArray[] = array($y,$x);  
     return array($y,$x);
   } 
  }
  $SpotsArray[] = array($lat,$long);  
  return array($lat, $long);
}

?>